;; -*- Scheme -*-
;;
;; Switzerland local load options
;;

(define-load-option 'KRYPT
  (standard-option-loader '(runtime krypt) #F "krypt"))

(define-load-option 'SWAT
  (lambda ()
    (let ((swat-dir (system-library-directory-pathname "swat")))
      (with-working-directory-pathname swat-dir
	(lambda ()
	  (load "load"))))))

(define-load-option 'PC-SAMPLE
  (lambda ()
    (let ((dir "/scheme/7.4/linux/pcsample"))
      (with-working-directory-pathname dir
	(lambda ()
	  (load "load"))))))

(define-load-option 'HLSIM
  (lambda ()
    (load "/gunk/hlsim/stable-linux/loader")))

(define-load-option 'HLSIM-latest
  (lambda ()
    (load "/gunk/hlsim/build-linux/loader")))

(define (guarded-system-loader package-name place #!optional filename)
  (let ((directory
	 (let ((here (directory-pathname (current-load-pathname))))
	   (let ((directory
		  (pathname-new-directory here
					  (append (pathname-directory here)
						  (list 'UP place)))))
	     (if (file-directory? directory)
		 directory
		 (merge-pathnames place here))))))
    (lambda ()
      (if (not (name->package package-name))
	  (with-working-directory-pathname directory
	    (lambda ()
	      (load (if (default-object? filename) "make" filename))))))))

(define-load-option 'SF
  (guarded-system-loader '(scode-optimizer) "sf"))

(define-load-option 'CREF
  (guarded-system-loader '(cross-reference) "cref"))

(define-load-option 'EDWIN
  (guarded-system-loader '(edwin) "edwin"))

(define-load-option 'COMPILER
  (lambda () (load-option 'SF))
  (guarded-system-loader '(compiler) "compiler"))

(define-load-option 'STUDENT
  (guarded-system-loader '(student) "6001"))

(define-load-option 'SOS
  (guarded-system-loader '(runtime object-system) "sos" "load"))

(define-load-option 'RCS
  (guarded-system-loader '(rcs) "rcs"))

(further-load-options standard-load-options)